#include "DxLib.h"
#include <math.h>

#define LIGHT_NUM	(6)
#define DRAW_NUM	(3)
#define SPACE		(512.0f)

// Cg̐F
float LightDifColor[ LIGHT_NUM ][ 3 ] =
{
	{ 150.0f,   0.0f, 150.0f },
	{ 150.0f,   0.0f,   0.0f },
	{   0.0f, 150.0f,   0.0f },
	{   0.0f,   0.0f, 150.0f },
	{ 150.0f, 150.0f,   0.0f },
	{   0.0f, 150.0f, 150.0f },
} ;

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	int ModelHandle ;
	int PixelShaderHandle ;
	int VertexShaderHandle ;
	float LightRotateAngle ;
	int i, j ;
	float DrawX, DrawZ ;
	int PointLightHandle[ LIGHT_NUM ] ;

	// EChE[hŋN
	ChangeWindowMode( TRUE ) ;

	// cwCȕ
	if( DxLib_Init() < 0 )
	{
		// G[璼ɏI
		return -1 ;
	}

	// vO}uVF[_[fRDOgpłȂꍇ̓G[\ďI
	if( GetValidShaderVersion() < 300 )
	{
		// G[\
		DrawString( 0, 0, "vO}uVF[_[RDOgpłȂ̂悤ł", GetColor( 255,255,255 ) ) ;

		// L[͑҂
		WaitKey() ;
		
		// cwCǔn
		DxLib_End() ;

		// \tgI
		return 0 ;
	}

	// _VF[_[ǂݍ
	VertexShaderHandle = LoadVertexShader( "NormalMesh_PointLight6_PhongVS.vso" ) ;

	// sNZVF[_[ǂݍ
	PixelShaderHandle = LoadPixelShader( "NormalMesh_PointLight6_PhongPS.pso" ) ;

	// ̃bVfǂݍ
	ModelHandle = MV1LoadModel( "NormalBox.mqo" ) ;

	// `𗠉ʂɂ
	SetDrawScreen( DX_SCREEN_BACK ) ;

	// f̕`ɃIWiVF[_[gpݒnmɂ
	MV1SetUseOrigShader( TRUE ) ;

	// gp钸_VF[_[Zbg
	SetUseVertexShader( VertexShaderHandle ) ;

	// gpsNZVF[_[Zbg
	SetUsePixelShader( PixelShaderHandle ) ;

	// ώ@₷ʒuɃJړ
	SetCameraPositionAndTarget_UpVecY( VGet( 800.0f, 400.0f, -800.0f ), VGet( 0.0f, 0.0f, 0.0f ) ) ;

	// Cg̈ʒu]l
	LightRotateAngle = 0.0f ;

	// WCg𖳌ɂ
	SetLightEnable( FALSE ) ;

	// |CgCg쐬
	for( i = 0 ; i < LIGHT_NUM ; i ++ )
	{
		// Cgnh̍쐬
		PointLightHandle[ i ] = CreatePointLightHandle( VGet( 0.0f, 0.0f, 0.0f ), 1000.0f, 1.016523f, 0.010100f, 0.0020f ) ;

		// Cg̐Fݒ肷
		SetLightDifColorHandle(
			PointLightHandle[ i ],
			GetColorF(
				LightDifColor[ i ][ 0 ],
				LightDifColor[ i ][ 1 ],
				LightDifColor[ i ][ 2 ],
				0.0f
			)
		) ;

		// Cg̃ArGgJ[𖳌ɂ
		SetLightAmbColorHandle( PointLightHandle[ i ], GetColorF( 0.0f, 0.0f, 0.0f, 0.0f ) ) ;
	}

	// ESCL[܂Ń[v
	while( ProcessMessage() == 0 && CheckHitKey( KEY_INPUT_ESCAPE ) == 0 )
	{
		// ʂ
		ClearDrawScreen() ;

		// |CgCg̈ʒủ]lZ
		LightRotateAngle += 0.02f ;

		// |CgCg̈ʒu̍XV
		for( i = 0; i < LIGHT_NUM ; i ++ )
		{
			SetLightPositionHandle( 
				PointLightHandle[ i ],
				VGet( 
					sin( LightRotateAngle + DX_TWO_PI_F / LIGHT_NUM * i ) * 700.0f,
					400.0f,
					cos( LightRotateAngle + DX_TWO_PI_F / LIGHT_NUM * i ) * 700.0f
				)
			) ;
		}

		// f`
		DrawZ = - ( DRAW_NUM - 1 ) * SPACE / 2.0f ;
		for( i = 0 ; i < DRAW_NUM ; i ++ )
		{
			DrawX = - ( DRAW_NUM - 1 ) * SPACE / 2.0f ;
			for( j = 0 ; j < DRAW_NUM ; j ++ )
			{
				// ʒuݒ
				MV1SetPosition( ModelHandle, VGet( DrawX, 0.0f, DrawZ ) ) ;

				// `
				MV1DrawModel( ModelHandle ) ;

				DrawX += SPACE ;
			}
			DrawZ += SPACE ;
		}

		// ʂ̓e\ʂɔf
		ScreenFlip() ;
	}

	// ǂݍ񂾒_VF[_[̍폜
	DeleteShader( VertexShaderHandle ) ;

	// ǂݍ񂾃sNZVF[_[̍폜
	DeleteShader( PixelShaderHandle ) ;

	// ǂݍ񂾃f̍폜
	MV1DeleteModel( ModelHandle ) ;

	// cwCǔn
	DxLib_End() ;

	// \tg̏I
	return 0 ;
}
