// sNZVF[_[̓
struct PS_INPUT
{
	float2 TexCoords0      : TEXCOORD0 ;    // eNX`W
	float3 VPosition       : TEXCOORD1 ;    // W( r[ )
	float3 VNormal         : TEXCOORD2 ;    // @( r[ )
} ;

// sNZVF[_[̏o
struct PS_OUTPUT
{
	float4 Color0          : COLOR0 ;
} ;

// }eAp[^
struct MATERIAL
{
	float4 Diffuse ;      // fBt[YJ[
	float4 Specular ;     // XyLJ[
	float4 Power ;        // XyL̋
} ;

// Cgp[^
struct LIGHT
{
	float4 Position ;               // W( r[ )
	float3 Direction ;              // ( r[ )
	float4 Diffuse ;                // fBt[YJ[
	float4 Specular ;               // XyLJ[
	float4 Ambient ;                // ArGgJ[ƃ}eÃArGgJ[Z
	float4 Range_FallOff_AT0_AT1 ;  // x:L  y:X|bgCgpFallOff  z:ɂ錸pp[^O  w:ɂ錸pp[^P
	float4 AT2_SpotP0_SpotP1 ;      // x:ɂ錸pp[^Q  y:X|bgCgpp[^O( cos( Phi / 2.0f ) )  z:X|bgCgpp[^P( 1.0f / ( cos( Theta / 2.0f ) - cos( Phi / 2.0f ) ) )
} ;


// C++ Őݒ肷eNX`萔̒`
sampler  DiffuseMapTexture             : register( s0 ) ;		// fBt[Y}bveNX`
float4   cfAmbient_Emissive            : register( c1 ) ;		// G~bVuJ[ + }eAArGgJ[ * O[oArGgJ[
MATERIAL cfMaterial                    : register( c2 ) ;		// }eAp[^
float4   cfFactorColor                 : register( c5 ) ;		// sx
LIGHT    cfLight[ 6 ]                  : register( c32 ) ;		// Cgp[^


// |CgCǧvZ֐
inline void CalcPointLight(
	const in    PS_INPUT PSInput,
	const in    int      LightNo,
	const in    float3   Normal,
	const in    float3   V_to_Eye,
	      inout float4   TotalDiffuse,
	      inout float4   TotalSpecular
)
{
	float  DiffuseAngleGen ;
	float3 TempF3 ;
	float  Temp ;
	float3 lLightTemp ;
	float  lLightDistancePow2 ;
	float  lLightGen ;
	float3 lLightDir ;

	// CgxNǧvZ
	lLightDir = normalize( PSInput.VPosition.xyz - cfLight[ LightNo ].Position.xyz ) ;


	// lvZ =======================================================( Jn )

	// _ƃCgʒuƂ̋̓߂
	lLightTemp = PSInput.VPosition.xyz - cfLight[ LightNo ].Position.xyz ;
	lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

	// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
	lLightGen = 1.0f / ( cfLight[ LightNo ].Range_FallOff_AT0_AT1.z + cfLight[ LightNo ].Range_FallOff_AT0_AT1.w * sqrt( lLightDistancePow2 ) + cfLight[ LightNo ].AT2_SpotP0_SpotP1.x * lLightDistancePow2 ) ;

	// LO猸őɂ鏈
	lLightGen *= step( lLightDistancePow2, cfLight[ LightNo ].Range_FallOff_AT0_AT1.x ) ;

	// lvZ =======================================================( I )


	// fBt[YFvZ

	// fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, -lLightDir ) ) ;

	// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * }eAfBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
	TotalDiffuse += ( cfLight[ LightNo ].Diffuse * cfMaterial.Diffuse * DiffuseAngleGen + cfLight[ LightNo ].Ambient ) * lLightGen ;


	// XyLJ[vZ

	// n[txNǧvZ
	TempF3 = normalize( V_to_Eye - lLightDir ) ;

	// Temp = pow( max( 0.0f, N * H ), cfMaterial.Power.x )
	Temp = pow( max( 0.0f, dot( Normal, TempF3 ) ), cfMaterial.Power.x ) ;

	// XyLJ[~ϒl += Temp * EX|bgCg̊px * Cg̃XyLJ[
	TotalSpecular += Temp * lLightGen.x * cfLight[ LightNo ].Specular ;
}



// main֐
PS_OUTPUT main( PS_INPUT PSInput )
{
	PS_OUTPUT PSOutput ;
	float4 TextureDiffuseColor ;
	float4 SpecularColor ;
	float3 Normal ;
	float4 TotalDiffuse ;
	float4 TotalSpecular ;
	float3 V_to_Eye ;


	// @̏
	Normal = normalize( PSInput.VNormal ) ;

	// _W王_ւ̃xNg𐳋K
	V_to_Eye = normalize( -PSInput.VPosition ) ;

	// fBt[YJ[ƃXyLJ[̒~ϒl
	TotalDiffuse  = float4( 0.0f, 0.0f, 0.0f, 0.0f ) ;
	TotalSpecular = float4( 0.0f, 0.0f, 0.0f, 0.0f ) ;


	// |CgCgO`T̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	CalcPointLight( PSInput, 0, Normal, V_to_Eye, TotalDiffuse, TotalSpecular ) ;
	CalcPointLight( PSInput, 1, Normal, V_to_Eye, TotalDiffuse, TotalSpecular ) ;
	CalcPointLight( PSInput, 2, Normal, V_to_Eye, TotalDiffuse, TotalSpecular ) ;
	CalcPointLight( PSInput, 3, Normal, V_to_Eye, TotalDiffuse, TotalSpecular ) ;
	CalcPointLight( PSInput, 4, Normal, V_to_Eye, TotalDiffuse, TotalSpecular ) ;
	CalcPointLight( PSInput, 5, Normal, V_to_Eye, TotalDiffuse, TotalSpecular ) ;

	// |CgCgO`T̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )


	// o̓J[vZ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// TotalDiffuse = CgfBt[YJ[~ϒl + ( }eÃArGgJ[ƃO[oArGgJ[Ẑƃ}eAG~bVuJ[Z )
	TotalDiffuse += cfAmbient_Emissive ;

	// SpecularColor = Cg̃XyLJ[~ϒl * }eÃXyLJ[
	SpecularColor = TotalSpecular * cfMaterial.Specular ;

	// o̓J[ = TotalDiffuse * eNX`J[ + SpecularColor
	TextureDiffuseColor = tex2D( DiffuseMapTexture, PSInput.TexCoords0.xy ) ;
	PSOutput.Color0.rgb = TextureDiffuseColor.rgb * TotalDiffuse.rgb + SpecularColor.rgb ;

	// At@l = eNX`At@ * }eÃfBt[YAt@ * sx
	PSOutput.Color0.a = TextureDiffuseColor.a * cfMaterial.Diffuse.a * cfFactorColor.a ;

	// o̓J[vZ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )


	// o̓p[^Ԃ
	return PSOutput ;
}


